/*
 * BoxFillerPreparator.hpp
 *
 *  Created on: Sep 2, 2014
 *      Author: heber
 */

#ifndef BOXFILLERPREPARATOR_HPP_
#define BOXFILLERPREPARATOR_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "BaseFillerPreparator.hpp"

#include <vector>

#include "LinearAlgebra/Vector.hpp"

class RealSpaceMatrix;

/** This class prepares a filler for filling the whole domain at specific points.
 *
 */
class BoxFillerPreparator :
  public BaseFillerPreparator
{
public:
    BoxFillerPreparator(molecule *_filler);
    ~BoxFillerPreparator();

    void addCubeMesh(
        const std::vector<unsigned int> _counts,
        const Vector &_offset,
        const RealSpaceMatrix &_M);

};


#endif /* BOXFILLERPREPARATOR_HPP_ */
